//+------------------------------------------------------------------+
//|                                                         Pv-2.mq4 |
//|                                                          |
//|                                                Skype privalov-sv |
//|                    Candid' (http://candid.110mb.com/) |
//+------------------------------------------------------------------+
#define Pi 3.14159265358979323846

#property copyright ""
#property link      "Skype privalov-sv"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  Blue
#property  indicator_width1  1

#import "#_lib_FFT.ex4"
void realfastfouriertransform(double& a[], int tnn, bool inversefft); 
#import
extern   int    n      = 5;    //  - 
extern   bool   h      = true;
extern   int   Depth      = 1000;
//---- indicator buffers
double     Buffer1[];
//Global variables
int N;                  //N is number of data points.
double data[],amplitude,hpase;
int PreBars;
datetime BarTime;
int MinBars;
int StartPos;
int pos;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   N=MathPow(2,n);
   MinBars = N+Depth+1;
   ArrayResize(data,N);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   IndicatorDigits(Digits+Digits);
//---- indicator buffers mapping
   SetIndexBuffer(0,Buffer1);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Pv-42("+n+","+h+")");
//   SetIndexLabel(0,"amplitude");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator reset function                                  |
//+------------------------------------------------------------------+
int Reset() {
  PreBars = 0;
  BarTime = 0;
  return(Depth);
}
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start() {
  if (Bars == PreBars) return(0);
  if (Bars < MinBars) {
    Alert(":    ");
    return(0);
  }  
  if (Bars-PreBars == 1 && BarTime==Time[1]) StartPos = 1;
  else StartPos = Reset();
  PreBars = Bars;  
  BarTime=Time[0];
  for (pos=StartPos;pos>0;pos--) {
    for(int i=0;i<N;i++) data[i]=Close[i+pos];
    realfastfouriertransform(data,N,false);   //   CLOSE  
    amplitude=0; //  
    hpase=0;
    for(i=1;i<N/2;i++) {
      amplitude=amplitude+data[i*2];
      if (data[2*i] != 0.0) {
        hpase=hpase+MathArctan(data[2*i+1]/data[2*i]);
      } else {
        if (data[2*i+1] > 0.0) hpase=hpase+Pi/2;
        else hpase=hpase-Pi/2;
      }
    }
    if(h)Buffer1[pos]=amplitude;else Buffer1[pos]=hpase;//   
  }
  return(0);
}
//+------------------------------------------------------------------+
//---------------------------------------------------------------------+